{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module System.Curry_Path
  ( d_C_dirsInPath, d_C_fileInPath, d_C_getFileInPath )
  where

import Basics
import qualified Data.Curry_List
import qualified Curry_Prelude
import qualified System.Curry_Directory
import qualified System.Curry_Environment
import qualified System.Curry_FilePath


d_C_dirsInPath :: Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_dirsInPath cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (System.Curry_Environment.d_C_getEnv (Curry_Prelude.toCurryString
  "PATH") cd cs) cd cs) d_OP_dirsInPath_dot_uscore_hash_lambda2 cd cs

d_OP_dirsInPath_dot_uscore_hash_lambda2 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_dirsInPath_dot_uscore_hash_lambda2 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (Data.Curry_List.d_C_split (Curry_Prelude.d_C_flip (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)
  (System.Curry_FilePath.d_C_searchPathSeparator cd cs)) x2 cd cs) cd cs

d_C_fileInPath :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_fileInPath x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (d_C_dirsInPath cd cs) cd cs) (d_OP_fileInPath_dot_uscore_hash_lambda5
  x1) cd cs

d_OP_fileInPath_dot_uscore_hash_lambda5 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.C_Bool
d_OP_fileInPath_dot_uscore_hash_lambda5 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_lt_dollar_gt
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Functor_hash_Prelude_dot_IO cd
  cs) (Curry_Prelude.d_C_or cd cs) cd cs) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_mapM
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dot System.Curry_Directory.d_C_doesFileExist
  (Curry_Prelude.d_C_flip (System.Curry_FilePath.d_OP_lt_slash_gt cd cs) x1) cd
  cs) cd cs) x3 cd cs) cd cs

d_C_getFileInPath :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_getFileInPath x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (d_C_dirsInPath cd cs) cd cs) (d_OP_getFileInPath_dot_checkPath_dot_8
  x1) cd cs

d_OP_getFileInPath_dot_checkPath_dot_8 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_getFileInPath_dot_checkPath_dot_8 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) Curry_Prelude.C_Nothing cd cs
  Curry_Prelude.OP_Cons x3 x4 -> let x5 = Curry_Prelude.d_C_apply
                                       (Curry_Prelude.d_C_apply
                                       (System.Curry_FilePath.d_OP_lt_slash_gt
                                       cd cs) x3 cd cs) x1 cd cs
    in Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) (System.Curry_Directory.d_C_doesFileExist x5 cd cs) cd cs)
    (d_OP_getFileInPath_dot_checkPath_dot_8_dot_uscore_hash_lambda8 x5 x1 x4) cd
    cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_getFileInPath_dot_checkPath_dot_8 x1 l cd cs)
    (d_OP_getFileInPath_dot_checkPath_dot_8 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_getFileInPath_dot_checkPath_dot_8 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_getFileInPath_dot_checkPath_dot_8 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "System.Path.getFileInPath.checkPath.8" [show x1, show x2] info)
  _ -> failCons cd (consFail "System.Path.getFileInPath.checkPath.8" (showCons
    x2))

d_OP_getFileInPath_dot_checkPath_dot_8_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_getFileInPath_dot_checkPath_dot_8_dot_uscore_hash_lambda8 x1 x2 x3 x4 cd cs =
  case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) (System.Curry_Directory.d_C_getAbsolutePath x1 cd cs) cd cs)
    (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) (acceptCs id Curry_Prelude.C_Just) cd cs) cd cs
  Curry_Prelude.C_False -> d_OP_getFileInPath_dot_checkPath_dot_8 x2 x3 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_getFileInPath_dot_checkPath_dot_8_dot_uscore_hash_lambda8 x1 x2 x3 l
    cd cs) (d_OP_getFileInPath_dot_checkPath_dot_8_dot_uscore_hash_lambda8 x1 x2
    x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_getFileInPath_dot_checkPath_dot_8_dot_uscore_hash_lambda8 x1 x2 x3 z cd
    cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x ->
    d_OP_getFileInPath_dot_checkPath_dot_8_dot_uscore_hash_lambda8 x1 x2 x3 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "System.Path.getFileInPath.checkPath.8._#lambda8" [show x1, show x2, show x3
    , show x4] info)
  _ -> failCons cd (consFail "System.Path.getFileInPath.checkPath.8._#lambda8"
    (showCons x4))

